% La fonction "basket_pref" estime la probabilité de victoire de l'équipe
% de Nancy, qui porte ici le numéro 14, par la méthode de rejet (pour la
% loi d'échantillonnage préférentiel définie dans le polycopié). "Nsim"
% est le nombre de simulations demandées. Je ne commente que les
% différences avec le code de basket_14.
function basket_pref ()
Nsim = 10000;
global NANCY;
NANCY = 14;
% La probabilité que nous cherchons ne s'écrivant plus comme l'espérance
% d'une indicatrice, nous devons maintenir séparément la somme et la
% somme des carrés.
somme_f = 0;
somme_f2 = 0;
for i = 1 : Nsim
    % La fonction "championne_Q" à laquelle nous allons faire appel
    % fonctionne comme "championne", mais a deux différences importantes
    % près: 1. La loi de simulation est la loi d'échantillonnage Q; 2. La
    % fonction renvoie non seulement qui est la championne, mais aussi
    % quelle est la densité dP/dQ au point simulé. On stocke
    % respectivement ces deux valeurs de retour dans "ch" et "densite".
    [ch, densite] = championne_Q ();
    % Nous appelons "f" la réalisation de la fonction dont on va prendre
    % l'espérance.
    f = (ch == NANCY) * densite;
    somme_f = somme_f + f;
    somme_f2 = somme_f2 + f * f;
end
moy = somme_f / Nsim;
var_f = somme_f2 / Nsim - moy * moy;
ect_estr = sqrt (var_f / Nsim);
fprintf ('La probabilité de victoire hde Nancy est ');
fprintf ('%f ± %f %%.\n', 100 * moy, 1.96 * 100 * ect_estr);
return
end