% La fonction "centrale_pref" applique la méthode d'échantillonnage
% préférentiel pour calculer le risque d'accident.
function centrale_pref (Nsim)
global m C R Cinv;
m = [-3 -4 -5];
C = [1, .1, .2; .1, 1, .3; .2, .3, 1];
R = chol(C);
% "Cinv" est la matrice inverse de C, utilisée pour le calcul de la
% densité.
Cinv = inv (C);
% La variable dont on estime l'espérance n'étant plus une indicatrice, il
% faut maintenir séparément la somme et la somme des carrés.
somme_f = 0;
somme_f2 = 0;
for i = 1: Nsim
    % Cette fois-ci on échantillonne XYZ selon la loi Q.
    XYZ = tirer_Q ();
    % La fonction dont on évalue l'espérance doit tenir compte de la
    % densité.
    f = all (XYZ >= 0) * densitePQ (XYZ);
    somme_f = somme_f + f;
    somme_f2 = somme_f2 + f * f;
end
moy = somme_f / Nsim;
var_f = somme_f2 / Nsim - moy * moy;
ect_estr = sqrt (var_f / Nsim);
fprintf ('La probabilité d''accident est estimée à ');
fprintf ('%e ± %e.\n', moy, 1.96 * ect_estr);
fprintf ('(Note : Intervalle de confiance standard à 95 %%).\n');
return
end
