% La fonction "keno_simple" estime l'espérance de gain d'un joueur de Keno
% par la méthode de Monte-Carlo simple.
function keno_simple ()
% "Nsim" est le nombre de simulations effectuées.
Nsim = 1000000;
% "Ncoch" est le nombre de numéros à cocher.
Ncoch = 16;
% "total" est le total des réultats obtenus au cours des diverses
% simulations.
total = 0;
% On lance la boucle de simulations.
for i = 1 : Nsim
    % On appelle "carton" la donnée des numéros cochés par le joueur,
    % "carton(p)" désignant le numéro choisi à p points. Puisque la loi du
    % gain du joueur est la même quels que soient les numéros cochés, on
    % utilisera toujours le même carton.
    carton = 1 : Ncoch;
    % À l'aide de la fonction "tirage" pour simuler le tirage, de la
    % fonction "score" pour calculer le score à partir de "carton" et
    % "tirage", et de la fonction "gain" qui associe le gain correspondant
    % au score, on détermine la quantité d'argent gagnée par le joueur,
    % qu'on ajoute à "total".
    total = total + gain (score (carton, tirage ()));
end
% "moyenne" est le gain moyen, qui estime l'espérance de gain.
moyenne = total / Nsim;
% On affiche le résultat.
fprintf ('L''espérance de gain du Keno est estimée à ');
fprintf ('%f €.\n', moyenne);
% On quitte le programme.
return
end
