#include "stdbool.h"
#include "stdio.h"
#include "stdlib.h"

#include "math.h"

#define Nsim 1000000
#define Ncoch 16
#define Ntir 16
#define Nnum 64
#define score_maximal 136

void calcul_gains (double (*tableau_gains)[score_maximal + 1]);
void tirage_reduit (bool (*letirage)[Ncoch]);
double rand01 (void);

int main ()
{
  printf ("%d\n", RAND_MAX);
  double total = 0;
  double total_carres = 0;
  double tableau_gains[score_maximal + 1];
  bool letirage[Ncoch];
  calcul_gains (&tableau_gains);
  for (int i = 0; i < Nsim; ++i)
    {
      tirage_reduit (&letirage);
      int lescore = 0;
      for (int j = 0; j < Ncoch; ++j)
        {
          lescore += letirage[j] ? j + 1 : 0;
        }
      double legain = tableau_gains[lescore];
      total += legain;
      total_carres += legain * legain;
    }
  double moyenne = total / Nsim;
  double variance_gain = total_carres / Nsim - moyenne * moyenne;
  double ect_estimtr = sqrt (variance_gain / Nsim);
  double c0 = -1.65;
  double c1 = +3.10;
  printf ("Avec un risque de 1 ‰ pour la sous-estimation, resp. de 5 %% pour la surestimation, l'espérance de gain du Keno se situe dans l'intervalle [%f, %f] €.\n", moyenne + c0 * ect_estimtr, moyenne + c1 * ect_estimtr);
  return EXIT_SUCCESS;
}


void calcul_gains (double (*tableau_gains)[score_maximal + 1])
{
  int seuil = 50;
  double g = 5;
  int s;
  for (s = 0; s < seuil; ++s)
    {
      (*tableau_gains)[s] = 0;
    }
  s = seuil;
  while (true)
    {
      (*tableau_gains)[s] = g;
      ++s;
      if (s > score_maximal)
        {
          break;
        }
      g = floor ((11 * g + 5) / 10);
    }
  return;
}


void tirage_reduit (bool (*letirage)[Ncoch])
{
  int Nrestant = Ntir;
  for (int i = 0; i < Ncoch; ++i)
    {
      if (rand01 () < (double)Nrestant / (Nnum - i))
        {
          (*letirage)[i] = true;
          --Nrestant;
        }
      else
        {
          (*letirage)[i] = false;
        }
    }
  return;
}


double rand01 (void)
{
  return (rand () / (RAND_MAX + 1.) + rand () + .5) / (RAND_MAX + 1.);
}
