% La fonction "tirage" simule le tirage du jeu de Keno. Le résultat est
% renvoyé sous la forme d'un vecteur de "t" constitué de true et de false,
% t(n) étant vrai si et seulement si le numéro n a été tiré.
function t = tirage ()
% "Nnum" note le nombre total de numéros existant.
Nnum = 64;
% "Ntir" désigne le nombre de numéros à tirer.
Ntir = 16;
% "t" est le tirage qui va être effectué.
t = zeros (1, Nnum);
for i = 1 : Ntir
    % Boucle de tirage du numéro.
    while (true)
        % "numero" est le numéro tiré, à priori uniforme entre 1 et Nnum.
        numero = ceil (rand () * Nnum);
        % Cependant, on ne peut accepter ce numéro que s'il est différent
        % de ceux déjà tirés; sinon il faut recommencer.
        if (~t(numero))
            t(numero) = true;
            break;
        end
    end
end
return
end
