% La fonction "enlapin" dit si le point représenté par le nombre complexe
% "z" appartient ou non au lapin de Douady.
function reponse = enlapin (z)
% On calcule la valeur exacte de la constante apparaissant dans la formule
% d'itération, notée "c".
c = calculDeC ();
% On lance la boucle des itérations de z jusqu'à pouvoir déterminer si
% c'est un point du lapin ou non.
while true
    if (abs(z) < .25)
        % Cas où z initial appartenait au lapin.
        reponse = true;
        break;
    elseif (abs(z) > 2.)
        % Le z initial n'appartenait pas au lapin.
        reponse = false;
        break;
    else
        z = z * z + c;
    end
end
return
end
