% La fonction "strategieC" fait une simulation du jeu en suivant la
% stratégie de Charlotte. Elle renvoie true en cas de succes, et false en
% cas d'échec.
function resultat = strategieC ()
% La variable "des" est un 5-vecteur qui stocke les valeurs des dés devant
% le joueur. On commence par le premier lancer.
des = ceil (6 * rand (1, 5));
% On va relancer deux fois les dés, d'où la boucle ci-dessous.
for i = 1: 2
    % La fonction auxiliaire "choixC" est au centre de la stratégie de
    % Charlotte: elle dit, sachant à quel stade du jeu on en est, pour un
    % ensemble de dés fixés, quels sont les dés que Charlotte choisit de
    % relancer ou pas.
    choix = choixC (i, des);
    % On relance les dés que Charlotte veut relancer.
    for j = 1: 5
        if (choix(j))
            des(j) = ceil (6 * rand ());
        end
    end
end
resultat = (sum (des) >= 24);
return
end